<html>
<head>
<title>OgreGrid2DPageStrategy.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_b4dabe1aeee1fabc669d37783945a897.html">Paging</a>      </li>
      <li class="navelem"><a class="el" href="dir_c90181f353a19ac84e93eaccff6d8392.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGrid2DPageStrategy.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGrid2DPageStrategy_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Ogre_Grid2DPageStrategy_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Ogre_Grid2DPageStrategy_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePagingPrerequisites_8h.html">OgrePagingPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePageStrategy_8h.html">OgrePageStrategy.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector2_8h.html">OgreVector2.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreQuaternion_8h.html">OgreQuaternion.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre
<a name="l00039"></a>00039 {
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00050"></a><a class="code" href="group__Paging.html#ga725e3c2dccf1dbcec4a12f165681317c">00050</a>     <span class="keyword">enum</span> <a class="code" href="group__Paging.html#ga725e3c2dccf1dbcec4a12f165681317c" title="The 2D grid mode.">Grid2DMode</a>
<a name="l00051"></a>00051     {
<a name="l00053"></a><a class="code" href="group__Paging.html#gga725e3c2dccf1dbcec4a12f165681317caf8642c1227dd868584dc53f3edfc65ce">00053</a>         <a class="code" href="group__Paging.html#gga725e3c2dccf1dbcec4a12f165681317caf8642c1227dd868584dc53f3edfc65ce" title="Grid is in the X/Z plane.">G2D_X_Z</a> = 0, 
<a name="l00055"></a><a class="code" href="group__Paging.html#gga725e3c2dccf1dbcec4a12f165681317ca8bd62cc6b4ce83a9bd8bc84da5600d9b">00055</a>         <a class="code" href="group__Paging.html#gga725e3c2dccf1dbcec4a12f165681317ca8bd62cc6b4ce83a9bd8bc84da5600d9b" title="Grid is in the X/Y plane.">G2D_X_Y</a> = 1, 
<a name="l00057"></a><a class="code" href="group__Paging.html#gga725e3c2dccf1dbcec4a12f165681317ca6d3b2d3c9720ebf2ab1b24fc3d1bfb18">00057</a>         <a class="code" href="group__Paging.html#gga725e3c2dccf1dbcec4a12f165681317ca6d3b2d3c9720ebf2ab1b24fc3d1bfb18" title="Grid is in the Y/Z plane.">G2D_Y_Z</a> = 2
<a name="l00058"></a>00058     };
<a name="l00120"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html">00120</a>     <span class="keyword">class </span><a class="code" href="OgrePagingPrerequisites_8h.html#a12507ffbcb05d7b7af41403ff7db8a5c">_OgrePagingExport</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html" title="Specialisation of PageStrategyData for Grid2DPageStrategy.">Grid2DPageStrategyData</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1PageStrategyData.html" title="Abstract marker class representing the data held against the PagedWorldSection which is specifically ...">PageStrategyData</a>
<a name="l00121"></a>00121     {
<a name="l00122"></a>00122     <span class="keyword">protected</span>:
<a name="l00124"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a0efec72f1a270ebe5ac0258cf9550da7">00124</a>         <a class="code" href="group__Paging.html#ga725e3c2dccf1dbcec4a12f165681317c" title="The 2D grid mode.">Grid2DMode</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a0efec72f1a270ebe5ac0258cf9550da7" title="Orientation of the grid.">mMode</a>;
<a name="l00126"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a1629140eb50c293d31c6857594312505">00126</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a1629140eb50c293d31c6857594312505" title="Origin (world space)">mWorldOrigin</a>;
<a name="l00128"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a28949c76d2ee4938d704c5cd212ae624">00128</a>         <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a28949c76d2ee4938d704c5cd212ae624" title="Origin (grid-aligned world space)">mOrigin</a>;
<a name="l00130"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aff88b3748ed76a27da5a660bf0ae174e">00130</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aff88b3748ed76a27da5a660bf0ae174e" title="Grid cell (page) size.">mCellSize</a>;
<a name="l00132"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a4b3539bf3f22b11fcbdc58131bac9ae5">00132</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a4b3539bf3f22b11fcbdc58131bac9ae5" title="Load radius.">mLoadRadius</a>;
<a name="l00134"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#acef410ebc662f303f9f7c85fe9af6deb">00134</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#acef410ebc662f303f9f7c85fe9af6deb" title="Hold radius.">mHoldRadius</a>;
<a name="l00135"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a4698f34331dd97851dc05c2e837013aa">00135</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a4698f34331dd97851dc05c2e837013aa">mLoadRadiusInCells</a>;
<a name="l00136"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a61e358d1480dc8d916fe26076280c9ae">00136</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a61e358d1480dc8d916fe26076280c9ae">mHoldRadiusInCells</a>;
<a name="l00137"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a5a144602e0dcf9053008a70df8438c0a">00137</a>         <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a5a144602e0dcf9053008a70df8438c0a">mMinCellX</a>;
<a name="l00138"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a151816f549af0c4d9916b4e7ecaa81fe">00138</a>         <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a151816f549af0c4d9916b4e7ecaa81fe">mMinCellY</a>;
<a name="l00139"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a7760b903898bbe4ea0507746b76a5931">00139</a>         <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a7760b903898bbe4ea0507746b76a5931">mMaxCellX</a>;
<a name="l00140"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a4d3396d4becf8b670329650b04200352">00140</a>         <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a4d3396d4becf8b670329650b04200352">mMaxCellY</a>;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142         <span class="keywordtype">void</span> updateDerivedMetrics();
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="keyword">public</span>:
<a name="l00145"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#ab41c384b1be0abfb04b0309eb1ab34fc">00145</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#ab41c384b1be0abfb04b0309eb1ab34fc">CHUNK_ID</a>;
<a name="l00146"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a3bf4f66a557bf903e12c8e8145d4efbb">00146</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a3bf4f66a557bf903e12c8e8145d4efbb">CHUNK_VERSION</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148         <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html" title="Specialisation of PageStrategyData for Grid2DPageStrategy.">Grid2DPageStrategyData</a>();
<a name="l00149"></a>00149         ~<a class="code" href="classOgre_1_1Grid2DPageStrategyData.html" title="Specialisation of PageStrategyData for Grid2DPageStrategy.">Grid2DPageStrategyData</a>();
<a name="l00150"></a>00150 
<a name="l00152"></a>00152         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setMode(<a class="code" href="group__Paging.html#ga725e3c2dccf1dbcec4a12f165681317c" title="The 2D grid mode.">Grid2DMode</a> mode);
<a name="l00153"></a>00153 
<a name="l00155"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aa4143b3b5fb6a49756c3dfde3254c016">00155</a>         <span class="keyword">virtual</span> <a class="code" href="group__Paging.html#ga725e3c2dccf1dbcec4a12f165681317c" title="The 2D grid mode.">Grid2DMode</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aa4143b3b5fb6a49756c3dfde3254c016" title="Set the grid alignment mode.">getMode</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMode; }
<a name="l00156"></a>00156 
<a name="l00158"></a>00158         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOrigin(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; worldOrigin);
<a name="l00160"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a7acd1f54228e8cd83913ebe8e99d09a0">00160</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a7acd1f54228e8cd83913ebe8e99d09a0" title="Get the origin of the grid in world space.">getOrigin</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; worldOrigin) { <span class="keywordflow">return</span> mWorldOrigin; }
<a name="l00162"></a>00162         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCellSize(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sz);
<a name="l00164"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aa7eb463355a451d49defcfb14a64f6e3">00164</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aa7eb463355a451d49defcfb14a64f6e3" title="Get the size of the cells in the grid.">getCellSize</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCellSize; }
<a name="l00166"></a>00166         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setLoadRadius(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sz);
<a name="l00168"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a75a786bf0b40a8ef0f74f13064436db6">00168</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a75a786bf0b40a8ef0f74f13064436db6" title="Get the loading radius.">getLoadRadius</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLoadRadius; }
<a name="l00170"></a>00170         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setHoldRadius(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sz);
<a name="l00172"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#ad37222d9ec1409b0c29f13c450778cc5">00172</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#ad37222d9ec1409b0c29f13c450778cc5" title="Get the Holding radius.">getHoldRadius</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHoldRadius; }
<a name="l00174"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a73e0335ca55e8798854a7ee37bdc8b1c">00174</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a73e0335ca55e8798854a7ee37bdc8b1c" title="Get the load radius as a multiple of cells.">getLoadRadiusInCells</a>() { <span class="keywordflow">return</span> mLoadRadiusInCells; }
<a name="l00176"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a09a33b2a423ee71c271d414535712441">00176</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a09a33b2a423ee71c271d414535712441" title="Get the Hold radius as a multiple of cells.">getHoldRadiusInCells</a>(){ <span class="keywordflow">return</span> mHoldRadiusInCells; }
<a name="l00177"></a>00177 
<a name="l00179"></a>00179         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCellRange(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> minX, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> minY, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> maxX, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> maxY);
<a name="l00181"></a>00181         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCellRangeMinX(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> minX);
<a name="l00183"></a>00183         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCellRangeMinY(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> minY);
<a name="l00185"></a>00185         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCellRangeMaxX(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> maxX);
<a name="l00187"></a>00187         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setCellRangeMaxY(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> maxY);
<a name="l00189"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#af511dfcc90d59489a40c32e1d85ed48c">00189</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#af511dfcc90d59489a40c32e1d85ed48c" title="get the index range of all cells (values outside this will be ignored)">getCellRangeMinX</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMinCellX; }
<a name="l00191"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a7200797383fa8c3dfead34a9d47eaef7">00191</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#a7200797383fa8c3dfead34a9d47eaef7" title="get the index range of all cells (values outside this will be ignored)">getCellRangeMinY</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMinCellY; }
<a name="l00193"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aa0ef658e5eab0f6ff8d15445dfe0b381">00193</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#aa0ef658e5eab0f6ff8d15445dfe0b381" title="get the index range of all cells (values outside this will be ignored)">getCellRangeMaxX</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaxCellX; }
<a name="l00195"></a><a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#af454586a0a80de9e7ac0dae2d7a0f311">00195</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> <a class="code" href="classOgre_1_1Grid2DPageStrategyData.html#af454586a0a80de9e7ac0dae2d7a0f311" title="get the index range of all cells (values outside this will be ignored)">getCellRangeMaxY</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMaxCellY; }
<a name="l00196"></a>00196 
<a name="l00198"></a>00198         <span class="keywordtype">bool</span> load(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; stream);
<a name="l00200"></a>00200         <span class="keywordtype">void</span> save(<a class="code" href="classOgre_1_1StreamSerialiser.html" title="Utility class providing helper methods for reading / writing structured data held in a DataStream...">StreamSerialiser</a>&amp; stream);
<a name="l00201"></a>00201 
<a name="l00203"></a>00203         <span class="keyword">virtual</span> <span class="keywordtype">void</span> convertWorldToGridSpace(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; world, <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; grid);
<a name="l00205"></a>00205         <span class="keyword">virtual</span> <span class="keywordtype">void</span> convertGridToWorldSpace(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; grid, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; world);
<a name="l00207"></a>00207         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getMidPointGridSpace(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> x, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> y, <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; mid);
<a name="l00209"></a>00209         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getBottomLeftGridSpace(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> x, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> y, <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; bl);
<a name="l00214"></a>00214         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getCornersGridSpace(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> x, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> y, <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>* pFourPoints);
<a name="l00215"></a>00215         
<a name="l00217"></a>00217         <span class="keywordtype">void</span> determineGridLocation(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector2.html" title="Standard 2-dimensional vector.">Vector2</a>&amp; gridpos, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a>* x, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a>* y);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219         <a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> calculatePageID(<a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> x, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a> y);
<a name="l00220"></a>00220         <span class="keywordtype">void</span> calculateCell(<a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> inPageID, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a>* x, <a class="code" href="namespaceOgre.html#a1c37a43c04753c9ae0c17108c9e6c9d2">int32</a>* y);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222     };
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00231"></a><a class="code" href="classOgre_1_1Grid2DPageStrategy.html">00231</a>     <span class="keyword">class </span><a class="code" href="OgrePagingPrerequisites_8h.html#a12507ffbcb05d7b7af41403ff7db8a5c">_OgrePagingExport</a> <a class="code" href="classOgre_1_1Grid2DPageStrategy.html" title="Page strategy which loads new pages based on a regular 2D grid.">Grid2DPageStrategy</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1PageStrategy.html" title="Defines the interface to a strategy class which is responsible for deciding when Page instances are r...">PageStrategy</a>
<a name="l00232"></a>00232     {
<a name="l00233"></a>00233     <span class="keyword">public</span>:
<a name="l00234"></a>00234         <a class="code" href="classOgre_1_1Grid2DPageStrategy.html" title="Page strategy which loads new pages based on a regular 2D grid.">Grid2DPageStrategy</a>(<a class="code" href="classOgre_1_1PageManager.html" title="The PageManager is the entry point through which you load all PagedWorld instances, and the place where PageStrategy instances and factory classes are registered to customise the paging behaviour.">PageManager</a>* manager);
<a name="l00235"></a>00235 
<a name="l00236"></a>00236         ~<a class="code" href="classOgre_1_1Grid2DPageStrategy.html" title="Page strategy which loads new pages based on a regular 2D grid.">Grid2DPageStrategy</a>();
<a name="l00237"></a>00237 
<a name="l00238"></a>00238         <span class="comment">// Overridden members</span>
<a name="l00239"></a>00239         <span class="keywordtype">void</span> notifyCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam, <a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a>* section);
<a name="l00240"></a>00240         <a class="code" href="classOgre_1_1PageStrategyData.html" title="Abstract marker class representing the data held against the PagedWorldSection which is specifically ...">PageStrategyData</a>* createData();
<a name="l00241"></a>00241         <span class="keywordtype">void</span> destroyData(<a class="code" href="classOgre_1_1PageStrategyData.html" title="Abstract marker class representing the data held against the PagedWorldSection which is specifically ...">PageStrategyData</a>* d);
<a name="l00242"></a>00242         <span class="keywordtype">void</span> updateDebugDisplay(<a class="code" href="classOgre_1_1Page.html" title="Page class.">Page</a>* p, <a class="code" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a>* sn);
<a name="l00243"></a>00243         <a class="code" href="namespaceOgre.html#a5126a9c9fbccbfe4c78070263098acb2" title="Identifier for a page.">PageID</a> getPageID(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; worldPos, <a class="code" href="classOgre_1_1PagedWorldSection.html" title="Represents a section of the PagedWorld which uses a given PageStrategy, and which is made up of a gen...">PagedWorldSection</a>* section);
<a name="l00244"></a>00244     };
<a name="l00245"></a>00245 
<a name="l00248"></a>00248 }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
